<?php
/**
 * @file
 * Entity Sync callback related functions.
 */

/**
 * Entity update callback.
 */
function entitysync_sync_callback() {

  $entity_sync_packet = new EntitySyncPacket();

  if (!$entity_sync_packet->decode(file_get_contents('php://input'))) {
    drupal_add_http_header('Status', '403 Forbidden');
    drupal_exit();
  }

  drupal_alter('entitysync_receive', $entity_sync_packet);

  $entity = $entity_sync_packet->fetchEntity();

  if (!$entity) {
    drupal_add_http_header('Status', '409 Conflict');
    drupal_exit();
  }

  switch ($entity_sync_packet->op) {
    case 'del':
      entity_delete($entity_sync_packet->entityType, $entity);
      break;

    case 'sync':
      foreach ($entity_sync_packet->fields as $field_name => $field_data) {
        $entity->$field_name = $field_data;
      }
      entity_save($entity_sync_packet->entityType, $entity);
      break;

  }

  drupal_exit();
}
